import $ from 'jquery';
import moment from 'moment'
import './styles.scss'
import Editor from './editor'
import MD from './markdown'

moment.locale('nl')
// mermaid.initialize({startOnLoad: true})
// PrismJS.plugins.filterHighlightAll.reject.addSelector('.language-mermaid')
// PrismJS.plugins.filterHighlightAll.reject.addSelector('.language-dot')

// $(function () {
//     wikiGraph('.graph-network')
// })

/*
 * EVENTS
 */
$(document).on('keydown', '.keyboard-list', function (event) {
    if (!$(':visible', this).length) {
        return true
    }

    const $popup = $(this)
    if (event.key === 'Escape') {
        $popup.fadeOut()
        return false
    }

    return true
})

$(document).on('keydown', '#search-input', function (event) {
    let $ac = $('#autocomplete:visible');
    if (event.key === 'Escape') {
        $(this).val('');

        if ($ac.length) {
            $ac.fadeOut();
            return false;
        }
    }
    if (event.key === 'Enter') {
        _.defer(() => {
            let $a = $('#autocomplete li.selected > a');
            if ($a.length) $a[0].click()
        })
        return true;
    }

    if (!$ac.length) {
        return true;
    }

    if (event.key === 'ArrowDown') {
        let x = $ac.find('li.selected').removeClass('selected').next('li').addClass('selected')
        if (x.length) {
            x[0].scrollIntoView({behavior: "smooth", block: "nearest"})
        }
        return false
    }
    if (event.key === 'ArrowUp') {
        let x = $ac.find('li.selected').removeClass('selected').prev('li').addClass('selected')
        if (x.length) {
            x[0].scrollIntoView({behavior: "smooth", block: "nearest"})
        }
        return false
    }

    return true
})

document.querySelectorAll(".page-loader")
    .forEach((el, key, parent) => {
        let format = el.dataset.format
        let edit = el.dataset.edit
        fetch('/' + el.dataset.page + '?format=' + format)
            .then(res => edit ? res.json() : res.text())
            .then(text => {
                if (edit) {
                    new Editor(el, text).then(editor => editor.start());
                } else {
                    el.innerHTML = MD.render(text)
                }
            })
    })

$(document).on('click', '.calendar-update', function (event) {
    const cal = $(this).data('calendar')
    fetch('/api/calendar/' + cal)
        .then(res => res.text())
        .then(calendar => {
            $('.calendar').html(calendar)
        })
    return false
})
