/*
 * Wiki - A wiki with editor
 * Copyright (c) 2021 Peter Stuifzand
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package link

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestFormatHtmlTitle(t *testing.T) {

	tests := []struct {
		input, output string
	}{
		{input:  "hello", output: "hello"},
		{input:  "hello [[world]]", output: `hello <a href="world">[[world]]</a>`},
	}
	for _, test := range tests {
		s := FormatHtmlTitle(test.input)
		assert.Equal(t, test.output, string(s))
	}
}
